
/*

 FR.PRG

 14-01-2021

  COBA Systems Software
 BAST Open Source Project
 Business Account Software Technology
 www.cobasystems.com
 Program: Alaska Xbase++ 1.90.355 sl1
          XbTools, ADSDBE, eXpress++


 DIALOG BOX: VIEW, PRINT, PDF, EXCEL, EXIT
 =========================================
 FOR FASTREPORT ENGINE

*/







* FUNCTION TEST_FR()
*
* FUNCTION FR( FR3, cbrojdokumenta, cakcija, cnaslov )
* STATIC FUNCTION FRMENU( FR3, cbrojdokumenta, cakcija, cnaslov )
*  STATIC FUNCTION helptext(cbrojdokumenta)
*  STATIC FUNCTION FAST_REPORT(cakcija,cbrojdokumenta)
*    STATIC FUNCTION FR_PDF(Export_Broj)
*    STATIC FUNCTION FR_EXCEL(cExp_Obj,Export_Broj)
*
* FUNCTION koriguj_naziv_xml_fajla(xfile)
* FUNCTION koriguj_naziv_excel_xml_fajla(xfile)
* FUNCTION startuj_fajl_njegovim_programom( cUrl, lBackground, lAsync )


#include "Appevent.ch"
#include "Xbp.ch"
#include "Common.ch"
#include "Dll.ch"

#include "dcdialog.ch"

#include "FASTREP.CH"
// FASTREP.CH
// FASTREP.PRG
// FRSyst.DLL  3,63 MB ver. 4.12.1  27.03.2015




*
* - ova funkcija se poziva iz aplikacije sa svim ovde datim parametrima
*   a iz nje se poziva funkcija za fastreport: FAST_REPORT()
*
* - Pre poziva ove funkcije mora se formirati temporary DBF fajl
*             USE (FR_DBF) NEW SHARED ALIAS "FR_DBF"
*   i mora se otvoriti taj fajl kako bi ova funkcija mogla da ga koristi
*             FrPrn:SetWorkArea("FR_DBF", SELECT("FR_DBF"))
*
*-----------
*
* - this function is called from the application with all the parameters given here
*   and the fastreport function is called from it: FAST_REPORT()
*
* - A temporary DBF file must be formed before calling this function
*             USE (FR_DBF) NEW SHARED ALIAS "FR_DBF"
*   and that file must be opened for this function to use it
*             FrPrn: SetWorkArea ("FR_DBF", SELECT ("FR_DBF"))
*


*************************************************************************
FUNCTION FR(FR3, cbrojdokumenta, cnaslov, cakcija )
*************************************************************************

* cakcija := "STAMPA"     // print
* cakcija := "PREGLED"    // view
* cakcija := "DIZAJN"     // design
* cakcija := "PDF"
* cakcija := "EXCEL"

LOCAL radno := SELECT(), qq

DEFAULT  FR3            TO "1.FR3"     ,; // fr3 file
         cbrojdokumenta TO "100-0001"  ,; // Document number
         cakcija        TO "PREGLED"   ,; // view
         cnaslov        TO ;              // title in two lines
"View and print a document;Document number: "+cbrojdokumenta






* VANO: temporary fajl FR_DBF mora biti
* otvoren kao ALIAS "FR_DBF"
* IMPORTANT: temporary file FR_DBF must be
* opened as ALIAS "FR_DBF"
* USE (FR_DBF) NEW EXCLUSIVE ALIAS "FR_DBF" // FR_MAIN.PRG

  IF ALIAS()<>"FR_DBF"
     confirmbox(,"nema FR_DBF fajla")
     RETURN NIL
  ENDIF
  ***************
  SELECT "FR_DBF"
  ***************
  GO TOP

 DO WHILE .T.
  **************************
  // FR MENU:
  qq := FRMENU(fr3,;
           cbrojdokumenta,;
           cnaslov,;
           cakcija)
  **************************
  IF qq==0
     EXIT
  ENDIF

 ENDDO


  * SELECT "FR_DBF";USE // FR_MAIN.PRG
  SELECT(radno)

RETURN NIL







***************************************************************************
STATIC FUNCTION FRMENU(fr3, cbrojdokumenta, cnaslov, cakcija )
***************************************************************************
* cakcija := "STAMPA"
* cakcija := "PREGLED"
* cakcija := "DIZAJN"
* cakcija := "PDF"
* cakcija := "EXCEL"

LOCAL  GetList := {},  GetOptions, oDlg, oGroup, oFokus, lButton := .T.
LOCAL oParent := SetAppWindow()
LOCAL report_dll := GDE_EXE()+"\CSYSTEMS9.DLL" // GDE_EXE()+"\FRSyst.dll"

LOCAL co0,co1,co2,co3,co4,of1,of2,of3,of4,aCUR,oCUR
*================================================================
co1 := GRA_CLR_WHITE
co2 := GraMakeRGBColor({225,116,81})  //220,135,107
co3 := GRA_CLR_BLACK
co4 := GRA_CLR_YELLOW
aCUR := {"user32.dll",114}
oCUR := {"user32.dll",112}
*================================================================

SET CHARSET TO ANSI
SET DATE GERMAN

DEFAULT  fr3 TO            "1.FR3"     ,;
         cbrojdokumenta TO "F01-0001"  ,;   // zbog dialoga
         cnaslov TO        "Pregled i tampa dokumenta "+cbrojdokumenta ,;
         cakcija TO        "PREGLED"

PRIVATE report_file := GDE_EXE()+"\REPORT\"+fr3


  *===================================================================
  * K O N T R O L A  P O S T O J A N J A  R E P O R T  E N G I N E
  *
  *   REPORT GENERATOR FRX - Mora da postoji:
  *   - FastReport.PRG (vraper za poziv funkcija iz FRSyst.dll)
  *   - FRSyst.dll     (kod mene je to preimenovano u CSYSTEMS9.DLL)
  *   - FAKTURA.fr3    (formular fakture kreiran iz report dizajnera)

    IF FILE(report_dll) == .F.  // FRSyst.dll
       confirmbox(,report_dll,"Ne postoji Report Engine:")
       RETURN NIL
    ENDIF
    IF FILE(report_file) == .F.
       confirmbox(,report_file,"Ne postoji report fajl:")
       RETURN NIL
    ENDIF
  *===================================================================





  * R A D  B E Z  D I A L O G A
  ******************************
  * FAST_REPORT(cbrojdokumenta)
  ******************************





  *===================================================================
  * R A D  S A  D I A L O G O M
                                  // ikone iz:
   i_pregled := ICO_fr_pregled()  // COBA.DLL
   i_printer := ICO_fr_printer()  // COBA.DLL
   i_pdf     := ICO_fr_pdf()      // COBA.DLL
   i_excel   := ICO_fr_excel()    // COBA.DLL
   i_exit    := ICO_fr_exit()     // COBA.DLL


// NASLOVNO DUGME
  @ -0.5,1 ;
  DCPUSHBUTTONXP CAPTION cnaslov FONT "11.Arial Bold";
  SIZE 40,2.5 ACCELKEY xbeK_F1;
  ACTION {|| helptext(cbrojdokumenta) } ;
  CURSOR oCUR OUTLINE COLOR co1,co2 CLICKCOLOR co3,co4 TOOLTIP " Document "

// KOMANDNA DUGMAD
//-----
@ 2.5,1 DCTOOLBAR oToolBar SIZE 40,3 BUTTONSIZE 40/5,3
//----- 1
  DCADDBUTTONXP BITMAP i_pregled;
  ALIGN XBPALIGN_HCENTER+XBPALIGN_VCENTER ACCELKEY xbeK_TAB OBJECT o1;  // leva ruka je slobodna-u desnoj je mi
  PARENT oToolbar ;
  ACTION {|| cakcija:="PREGLED", DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList) } ;
  CURSOR aCUR OUTLINE COLOR co1,co2 CLICKCOLOR co3,co4 TOOLTIP " Pregled/View [ TAB ] "
//----- 2
  DCADDBUTTONXP BITMAP i_printer;
  ALIGN XBPALIGN_HCENTER+XBPALIGN_VCENTER ACCELKEY {asc("S"),asc("s")};
  PARENT oToolbar ;
  ACTION {|| cakcija:="STAMPA", DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList) } ;
  CURSOR aCUR OUTLINE COLOR co1,co2 CLICKCOLOR co3,co4 TOOLTIP " tampa/Print [ S ] "
//----- 3
  DCADDBUTTONXP BITMAP i_pdf;
  ALIGN XBPALIGN_HCENTER+XBPALIGN_VCENTER ACCELKEY {asc("P"),asc("p")};
  PARENT oToolbar ;
  ACTION {|| cakcija:="PDF", DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList) } ;
  CURSOR aCUR OUTLINE COLOR co1,co2 CLICKCOLOR co3,co4 TOOLTIP " Izvoz u PDF/Export in PDF [ P ] "

//----- 4
  DCADDBUTTONXP BITMAP i_excel ;
  ALIGN XBPALIGN_HCENTER+XBPALIGN_VCENTER ACCELKEY {asc("E"),asc("e")};
  PARENT oToolbar ;
  ACTION {|| cakcija:="EXCEL", DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList) } ;
  CURSOR aCUR OUTLINE COLOR co1,co2 CLICKCOLOR co3,co4 TOOLTIP " Izvoz u Excel/Export in Excel [ E ] "

//----- 5
  IZLAZ:=.F.
  DCADDBUTTONXP BITMAP i_exit ;
  ALIGN XBPALIGN_HCENTER+XBPALIGN_VCENTER ACCELKEY xbeK_ESC;
  PARENT oToolbar ;
  ACTION {|| IZLAZ:=.T.,DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList) } ;
  CURSOR aCUR OUTLINE COLOR co1,co2 CLICKCOLOR co3,co4 TOOLTIP " Izlaz/Exit [ Esc ] "



//----- 6
* * [F1]
* DCHOTKEY xbeK_F1 ACTION {|| helptext(cbrojdokumenta) }

 * [CTRL]+[SHIFT]+[F12]
 DCHOTKEY 721019 ACTION {|| cakcija:="DIZAJN", DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList) }
//-----


  DCGETOPTIONS NORESIZE ALWAYSONTOP ;  // NOTITLEBAR
  NOMINBUTTON NOMAXBUTTON NOESCAPEKEY NOTASKBAR

  DCREAD GUI TITLE fr3;
     FIT OPTIONS GetOptions ;
     MODAL ;
     SETFOCUS @o1   ; // APPWINDOW oParent ; // definisanje jednog prozora kao parenta ovom prozoru
     OWNER oParent  ; // parent je vlasnik ovog prozora
     PARENT @oDlg   ; // definisanje parenta ovog prozora zbog modalnog sledeceg prozora
     EVAL {|o| SetAppWindow(o) }
  *===================================================================

  * cbrojdokumenta

  IF IZLAZ==.F.

     IF cakcija=="PREGLED"
        FAST_REPORT(cakcija,cbrojdokumenta)
     ENDIF
     IF cakcija=="STAMPA"
        FAST_REPORT(cakcija,cbrojdokumenta)
     ENDIF
     IF cakcija=="PDF"
        FAST_REPORT(cakcija,cbrojdokumenta)
     ENDIF
     IF cakcija=="EXCEL"
        FAST_REPORT(cakcija,cbrojdokumenta)
     ENDIF

     IF cakcija=="DIZAJN"
        FAST_REPORT(cakcija,cbrojdokumenta)
     ENDIF

     RETURN 1

  ELSE
     RETURN 0
  ENDIF // IF IZLAZ==.F.

RETURN NIL

***************************************************************************
STATIC FUNCTION helptext(cbrojdokumenta)
***************************************************************************
LOCAL txt := "", cr := chr(13)+chr(10)
private ccbrojdokumenta := cbrojdokumenta
TEXT INTO txt WRAP cr //TRIMMED
PREGLED I TAMPA DOKUMENTA
     &ccbrojdokumenta
Dokument koji je uraen u fast report generatoru
moete pregledati na ekranu monitora, moete ga
odtampati na windows printeru ili pdf printeru,
moete ga konvertovati u EXCEL fajl, PDF fajl,
JPG fajl, RTF fajl i druge dostupne formate.

Export u Excel radie i u sluaju da u raunaru
nije instaliran program Excel, ali tada neete
moi da pregledate i tampate Excel tabelu.
Pregled Excel tabele radie samo ako je u vaem
raunaru instaliran Excel verzija 2010 i novija

(Izmena sa CTRL+SHIFT+F12 samo za programera)

-----------------------------------------------------
PREVIEW AND PRINT OF THE DOCUMENT
      &ccbrojdokumenta
A document made in a fast report generator
you can view it on the monitor screen, you can
view it print on a windows printer or pdf printer,
you can convert it to EXCEL file, PDF file,
JPG file, RTF file and other available formats.

Export to Excel will work even if in a computer
Excel is not installed, but then you will not
be able to view and print an Excel spreadsheet.
The Excel spreadsheet view will only work if it is
in yours computer installed Excel version 2010
and later

(Modify with CTRL+SHIFT+F12 for developers only)
ENDTEXT
 confirmbox(,txt,"PREVIEW AND PRINT OF THE DOCUMENT")
 CLEAR TYPEAHEAD
RETURN NIL







***************************************************************************
STATIC FUNCTION FAST_REPORT(cakcija,cbrojdokumenta)
***************************************************************************


//=========================================================================
//                             FASTREPORT FOR XBASE++
//=========================================================================

//------------------ Open FastReport

  PRIVATE FrPrn, lShowCustName := .f.
  FrPrn := frReportManager():new()
  FrPrn:SetVisualActions(FR_ACT_DISABLE)

//------------------ Open FastReport

//------------------ Run FastReport

   * moe direktno/can directly:
     *********************************************
     FrPrn:SetWorkArea("FR_DBF", SELECT("FR_DBF"))
     *********************************************

   * moe indirektno/can indirectly:
   * FrPrn:SetWorkArea(ALIAS(), SELECT(ALIAS()))


   * moe dve i vie DBF direktno/can two or more DBF directly:
   * FrPrn:SetWorkArea("FR_DBF1", SELECT("FR_DBF1"))
   * FrPrn:SetWorkArea("FR_DBF2", SELECT("FR_DBF2"))


   * moe bez aliasa polja, ali pii bez blankova i bez znaka ":="
   * can without field aliases, but write without blanks and without sign ":="
   *  FrPrn:SetFieldAliases("FR_DBF","IdNumber=ID_;IdName=NAME_;IdLocation=LOC_")
   *  DBF Fields: ID_, NAME_, LOC_

           FrPrn:LoadFromFile(report_file)

           IF cakcija     = "PREGLED"

              FrPrn:ShowReport()

           ELSEIF cakcija = "DIZAJN"

              FrPrn:DesignReport()

           ELSEIF cakcija = "STAMPA"

            //-----
              old_dialog  := FrPrn:PrintOptions:SetShowDialog(.T.)
              FrPrn:PrepareReport()
              FrPrn:Print(.t.)
              FrPrn:PrintOptions:SetShowDialog(old_dialog)
            //-----

           ELSEIF cakcija = "PDF"

                   FR_PDF(cbrojdokumenta)  // ovde

           ELSEIF cakcija = "EXCEL"

                   FR_EXCEL("XLSExport", cbrojdokumenta) // ovde
           ELSE
                   confirmbox(,"Programer","Stop")
           ENDIF

//------------------ Run FastReport

//------------------ Close FastReport
    FrPrn:ClearDataSets()
    FrPrn:DestroyFR()
//------------------ Close FastReport


//=========================================================================
//                             FASTREPORT FOR XBASE++
//=========================================================================


RETURN NIL






***********************************************************************
STATIC FUNCTION FR_PDF(Export_Broj) // C_FR_MENI.PRG
***********************************************************************
/*

 * ZBOG PROBLEMA SA NEDOZVOLJENIM ZNACIMA U NAZIVU PDF FAJLA
 * OVDE NAZIV FAJLA IMA SAMO DOZVOLJENE ZNAKE
 * A FOLDER U KOJI SE SMETA PDF FAJL JE FIKSIRAN NA C:\PDF
 * naziv PDF fajla moe da ima samo slova i brojeve i '_-'

 * DUE TO PROBLEMS WITH ILLEGAL SIGNS IN PDF NAME
 * THE FILE NAME HAS ONLY ALLOWED CHARACTERS
 * A FOLDER IN WHICH THE PDF FILE IS STORED IS FIXED TO C:\PDF
 * PDF file name can only have letters and numbers and '_-'


*/
* Export_Broj := "F33-0001"  // document number
* ExportDir   := "C:\PDF"    // fix

LOCAL radno := SELECT()



 *********************************************************
  PRIVATE ExportDir := "C:\PDF"
  DirMake(ExportDir)  // XbToolsIII++

  IF empty(Export_Broj) .or. Export_Broj==NIL
    PRIVATE ExportBroj := dtos(date())
  ELSE
    PRIVATE ExportBroj := Export_Broj
  ENDIF

  PRIVATE ExportFile := ExportDir +"\"+"FR_"+ ExportBroj+".PDF"

 *********************************************************


      PRIVATE cExpObj   := "PDFExport"  // SLUBENA VARIJABLA FASTREPORT PDF CREATORA
                                        // OFFICIAL VARIABLE FASTREPORT PDF CREATOR

      PRIVATE cExpFile  := ExportFile   // C:\PDF\F12-0033.PDF // full PATH

      PRIVATE lExpOpt   := .F.          // .F. ne aktivira filedialog za upis PDF filename
                                        // .F. does not activate the filedialog for writing PDF filename

      PRIVATE lExpOpen  := .T.          // .T. = otvara PDF file u default PDF readeru
                                        // .T. = opens a PDF file in the default PDF reader


          FrPrn:SetProperty("Report", "ShowProgress", .T.)
          FrPrn:PrepareReport()
          FrPrn:SetProperty(cExpObj, "ShowDialog", lExpOpt)
          //... Sergej Spirin je dozvolio otvaranje posle exporta
          //... Sergei Spirin allowed the opening after export
          FrPrn:SetProperty(cExpObj, "OpenAfterExport", lExpOpen)

          FrPrn:SetProperty(cExpObj, "FileName", cExpFile)
          ***********************
          FrPrn:DoExport(cExpObj)
          ***********************
          FrPrn:SetProperty("Report", "ShowProgress", .F.)



SELECT(radno)

     ConfirmBox(,;
    "a file has been created:"  +chr(13)+;
     var2char(cExpFile)         +chr(13)+;
    "","FR DOCUMENT",XBPMB_SYSMODAL)


RETURN NIL


***********************************************************************
STATIC FUNCTION FR_EXCEL(cExp_Obj,Export_Broj) // C_FR_MENI.PRG
***********************************************************************
/*

 * ZBOG PROBLEMA SA NEDOZVOLJENIM ZNACIMA U NAZIVU XLS FAJLA
 * OVDE NAZIV FAJLA IMA SAMO DOZVOLJENE ZNAKE
 * A FOLDER U KOJI SE SMETA EXCEL FAJL JE FIKSIRAN NA C:\EXCEL
 * naziv XLS fajla moe da ima samo slova i brojeve i '_-'

 * DUE TO PROBLEMS WITH ILLEGAL SIGNS IN XLS NAME
 * THE FILE NAME HAS ONLY ALLOWED CHARACTERS
 * A FOLDER IN WHICH THE EXCEL FILE IS STORED IS FIXED TO C:\EXCEL
 * XLS file name can only have letters and numbers and '_-'


*/
* SLUBENA VARIJABLA FASTREPORT PDF CREATORA
* OFFICIAL VARIABLE FASTREPORT PDF CREATOR
* cExp_Obj   := "XLSExport"    // XLS
* cExp_Obj   := "XLSXExport"   // XLSX
* cExp_Obj   := "XMLExport"    // XML
*---
* Export_Broj := "F33-0001"    // DOCUMENT NUMBER
* ExportDir   := "C:\EXCEL"    // FIX

LOCAL radno := SELECT()
LOCAL ext:=""


 ***********************************************************

  PRIVATE ExportDir := "C:\EXCEL"
  DirMake(ExportDir)

      IF cExp_Obj==NIL .or. empty(cExp_Obj)

         cExp_Obj   := "XLSExport"
       * cExp_Obj   := "XLSXExport"
       * cExp_Obj   := "XMLExport"

      ENDIF

     IF cExp_Obj == "XLSExport"
        ext := ".XLS"
     ENDIF
     IF cExp_Obj == "XLSXExport"
        ext := ".XLSX"
     ENDIF
     IF cExp_Obj == "XMLExport"
        ext := ".XML"
     ENDIF


  IF Export_Broj==NIL .or. empty(Export_Broj)

     PRIVATE ExportBroj := dtos(date())

  ELSE

     PRIVATE ExportBroj := Export_Broj

  ENDIF


     PRIVATE ExportFile := ExportDir + "\" + "FR_" + ExportBroj + ext

 ***********************************************************



      PRIVATE cExpObj   := cExp_obj     // SLUBENA VARIJABLA FASTREPORT PDF CREATORA
                                        // OFFICIAL VARIABLE FASTREPORT PDF CREATOR

      PRIVATE cExpFile  := ExportFile   // C:\PDF\F12-0033.PDF // full PATH

      PRIVATE lExpOpt   := .F.          // .F. ne aktivira filedialog za upis PDF filename
                                        // .F. does not activate the filedialog for writing PDF filename

      PRIVATE lExpOpen  := .T.          // .T. = otvara PDF file u default PDF readeru
                                        // .T. = opens a PDF file in the default PDF reader



          FrPrn:SetProperty("Report", "ShowProgress", .f.)
          FrPrn:PrepareReport()
          FrPrn:SetProperty(cExpObj, "ShowDialog", lExpOpt)
          FrPrn:SetProperty(cExpObj, "OpenExcelAfterExport", lExpOpen)

          FrPrn:SetProperty(cExpObj, "FileName", cExpFile)
          FrPrn:DoExport(cExpObj)

          FrPrn:SetProperty("Report", "ShowProgress", .t.)




SELECT(radno)


     ConfirmBox(,;
    "a file has been created:"  +chr(13)+;
     var2char(cExpFile)         +chr(13)+;
    "","FR DOCUMENT",XBPMB_SYSMODAL)


RETURN NIL











