/*

 FR_MAIN.prg

 14-01-2021

  COBA Systems Software
 BAST Open Source Project
 Business Account Software Technology
 www.cobasystems.com
 Program: Alaska Xbase++ 1.90.355 sl1
          XbTools, ADSDBE, eXpress++

 Kako napraviti aplikaciju za tampanje dokumenata
 iz FastReport generatora
 - na ekran monitora u preglednik
 - na izabrani windows printer,
 - u PDF fajl,
 - u EXCEL fajl

 How to make an application for printing documents
 from the FastReport generator
  - on the monitor screen in the viewer
  - to the selected windows printer,
  - in PDF file,
  - in EXCEL file

*/

#include "Gra.ch"
#include "Xbp.ch"
#include "Font.ch"
#include "Common.ch"
#include "Appevent.ch"

PROCEDURE AppSys
// Desktop remains application window
RETURN

PROCEDURE AppQuit
   CLOSE DATABASES
   QUIT
RETURN

***********************************************************************
PROCEDURE Main
***********************************************************************
LOCAL nEvent, mp1, mp2, oXbp
LOCAL cDirectory:=strtran(appname(.t.),appname())+"TMP\"

SET CHARSET TO ANSI
SET DATE GERMAN
SET CENTURY ON

msgbox("START TEST1")

      TEST1()   // LIST OF ARTICLES - PRICE LIST

msgbox("START TEST2")

      TEST2()   // LIST OF ARTICLES WITH BARCODE

RETURN







***********************************************************************
FUNCTION TEST1() // LIST OF ARTICLES - PRICE LIST
***********************************************************************
/*
  Da bi se koristila funkcija FR() prvo treba napraviti temporary
  DBF fajl koji sadi podatke za fastreport
*/
 LOCAL radno:=SELECT()
 LOCAL cDirectory:=strtran(appname(.t.),appname())+"TMP\"
 PRIVATE FR_DBF := GetUniqueFileName(cDirectory,"_")
 PRIVATE FR_NTX := GetUniqueFileName(cDirectory,"__")
 DirMake(cDirectory)
 * cDirectory ne sme da sadri nedozvoljene znakove
 * cDirectory must not contain illegal characters

 USE ROBA.DBF NEW SHARED VIA "DBFNTX"
 COPY ALL TO (FR_DBF) VIA "DBFNTX"
 USE

 USE (FR_DBF) NEW EXCLUSIVE VIA "DBFNTX" ALIAS "FR_DBF"
 INDEX ON ROBN_ TO (FR_NTX)

   *************************
    FR("1.FR3","N12345678")  // FR.PRG
   *************************

 USE
 DELETE FILE (FR_DBF)
 DELETE FILE (FR_NTX)
SELECT(radno)
RETURN NIL


***********************************************************************
FUNCTION TEST2()  // LIST OF ARTICLES WITH BARCODE
***********************************************************************
/*
  Da bi se koristila funkcija FR() prvo treba napraviti temporary
  DBF fajl koji sadi podatke za fastreport
*/
 LOCAL radno:=SELECT()
 LOCAL cDirectory:=strtran(appname(.t.),appname())+"TMP\"
 PRIVATE FR_DBF := GetUniqueFileName(cDirectory,"_")
 PRIVATE FR_NTX := GetUniqueFileName(cDirectory,"__")
 DirMake(cDirectory)
 * cDirectory ne sme da sadri nedozvoljene znakove
 * cDirectory must not contain illegal characters

 USE ROBA.DBF NEW EXCLUSIVE VIA "DBFNTX"
 COPY ALL TO (FR_DBF) VIA "DBFNTX"
 USE

 USE (FR_DBF) NEW EXCLUSIVE VIA "DBFNTX" ALIAS "FR_DBF"
 INDEX ON ROBN_ TO (FR_NTX)

   *************************
    FR("2.FR3","N12345678")  // FR.PRG
   *************************

 USE
 DELETE FILE (FR_DBF)
 DELETE FILE (FR_NTX)
SELECT(radno)
RETURN NIL


***************************************************************************
FUNCTION GDE_EXE()
***************************************************************************
LOCAL cDir := STRTRAN(APPNAME(.T.),"\"+APPNAME())
RETURN cDir

