//////////////////////////////////////////////////////////////////////
//
//  FastRep.PRG  FrSyst.dll verzija 4.12.1 (2015)
//               Radi ispravno kod formiranja PDF fajla
//               Ne radi sa starim LangRes fajlovima:
//                  Croatian.frc i Serbian.frc
//               pa rad sa LangRes treba iskljuiti:
//                *** FrPrn:LoadLangres("serbian.frc")
//               Modifikacija u liniji 914:
//               FrSyst.dll rename to CSYSTEMS9.DLL
//               www.cobasystems.com 05.05.2016
//               --------------------------------------
//               Curent copy is: Gates Canyon Inc
//               Registered to :
//               --------------------------------------
//  Copyright:
//       Spirin Sergey, Paritet Soft, (c) 1992-2007. All rights reserved.
//
//  Contents:
//       Source File for frReportManager and other classes for
//       "FastReport for Alaska XBase++"
//
//////////////////////////////////////////////////////////////////////

#include "Dll.ch"
#include "FastRep.ch"

//////////////////////////////////////////////////////////////////////
// frReportManager - this class is the main one.
//                   The class has all necessary methods for report
//                   loading and saving, design and viewing etc.
//////////////////////////////////////////////////////////////////////

CLASS frReportManager
   HIDDEN
      VAR _InitSyst, _FrNotifyError, _CloseSyst, _SetIcon, _SetTitle, _SetVisualActions,;
          _LoadLangRes, _ShowReport, _PrepareReport, _ShowPreparedReport, _DesignReport,;
          _LoadFromFile, _LoadFromBlob, _LoadFromResource, _SaveToFile, _SaveToBlob, _Clear,;
          _LoadStyleSheet, _Print, _GetErrors,;
          _DoExport, _GetProperty, _SetProperty, _SetEventHandler, _AddFunction,;
          _AddVariable, _SetVariable, _GetVariable, _DeletVariable, _DeletCategory,;
          _SetScriptVar, _GetScriptVar, _Calc, _SetWorkArea, _SetMasterDetail, _SetResyncPair,;
          _SetUserDataSet, _Resync, _SetFieldAliases, _RemoveDataSet, _ClearDataSets,;
          _ClearMasterDetail, _ClearResyncPair, _SetADOConnectStr, _SetADOConnectPartStr,;
          _StartManualBuild, _MemoAt, _SetDefaultFontProperty, _NewPage, _SetManualObjProperty,;
          _LineAt, _PictureAt, _SendMail

      METHOD PrepareCalls
   EXPORTED:
      VAR bSaveError                // Save Error handler
      VAR frSystHandle              // Handle of FastReport-dll
      VAR PrintOptions              // look frPrintOptions class
      VAR PreviewOptions            // look frPreviewOptions class
      VAR EngineOptions             // look frEngineOptions class
      VAR ReportOptions             // look frReportOptions class

      METHOD Init
      METHOD FrNotifyError
      METHOD SetIcon
      METHOD SetTitle
      METHOD SetVisualActions
      METHOD LoadLangRes
      METHOD DestroyFR

      METHOD GetProperty
      METHOD SetProperty
      METHOD SetEventHandler
      METHOD AddFunction

      METHOD ShowReport
      METHOD ShowPreparedReport
      METHOD PrepareReport
      METHOD DesignReport
      METHOD LoadFromFile
      METHOD LoadFromResource
      METHOD LoadFromBlob
      METHOD SaveToFile
      METHOD SaveToBlob
      METHOD Clear
      METHOD Print
      METHOD GetErrors
      METHOD DoExport
      METHOD LoadStyleSheet

      METHOD AddVariable
      METHOD SetVariable
      METHOD GetVariable
      METHOD DeleteVariable
      METHOD DeleteCategory

      METHOD SetScriptVar
      METHOD GetScriptVar
      METHOD Calc

      METHOD SetWorkArea
      METHOD SetMasterDetail
      METHOD SetResyncPair
      METHOD SetUserDataSet
      METHOD SetFieldAliases
      METHOD Resync
      METHOD ClearMasterDetail
      METHOD ClearResyncPair
      METHOD RemoveDataSet
      METHOD ClearDataSets
      METHOD SetADOConnectStr
      METHOD SetADOConnectPartStr

      METHOD StartManualBuild
      METHOD MemoAt
      METHOD SetDefaultFontProperty
      METHOD NewPage
      METHOD SetManualObjProperty
      METHOD LineAt
      METHOD PictureAt

      METHOD SendMail

ENDCLASS



//////////////////////////////////////////////////////////////////////
// frEngineOptions - A set of properties related to the FastReport
//                   engine:
//////////////////////////////////////////////////////////////////////

CLASS frEngineOptions
   HIDDEN:
       VAR frManager, _SetConvertNulls, _SetDoublePass, _SetPrintIfEmpty, _SetSilentMode,;
           _SetNewSilentMode, _SetMaxMemSize, _SetTempDir, _SetUseFileCache

       METHOD PrepareCalls
   EXPORTED:
       METHOD Init
       METHOD SetConvertNulls
       METHOD SetDoublePass
       METHOD SetPrintIfEmpty
       METHOD SetSilentMode
       METHOD SetNewSilentMode
       METHOD SetMaxMemSize
       METHOD SetTempDir
       METHOD SetUseFileCache
ENDCLASS


//////////////////////////////////////////////////////////////////////
// frPrintOptions - a set of properties, which relate to the report
//                  printing
//////////////////////////////////////////////////////////////////////

CLASS frPrintOptions
   HIDDEN:
       VAR frManager, _SetCopies, _SetCollate, _SetPageNumbers, _SetPrinter, _SetPrintPages,;
           _SetShowDialog, _SetReverse, _ClearOptions

       METHOD PrepareCalls
   EXPORTED:
       METHOD Init
       METHOD SetCopies
       METHOD SetCollate
       METHOD SetPageNumbers
       METHOD SetPrinter
       METHOD SetPrintPages
       METHOD SetShowDialog
       METHOD SetReverse
       METHOD ClearOptions
ENDCLASS


//////////////////////////////////////////////////////////////////////
// frPreviewOptions - A set of properties, relating to the report
//                    preview
//////////////////////////////////////////////////////////////////////

CLASS frPreviewOptions
   HIDDEN:
       VAR frManager, _SetAllowEdit, _SetButtons, _SetDoubleBuffered, _SetMaximized, _SetBounds,;
           _SetOutlineVisible, _SetOutlineExpand, _SetOutlineWidth, _SetShowCaptions, _SetZoom,;
           _SetZoomMode, _SetPictureCacheInFile

       METHOD PrepareCalls
   EXPORTED:
       METHOD Init
       METHOD SetAllowEdit
       METHOD SetButtons
       METHOD SetDoubleBuffered
       METHOD SetMaximized
       METHOD SetBounds
       METHOD SetOutlineVisible
       METHOD SetOutlineExpand
       METHOD SetOutlineWidth
       METHOD SetShowCaptions
       METHOD SetZoom
       METHOD SetZoomMode
       METHOD SetPictureCacheInFile
ENDCLASS


//////////////////////////////////////////////////////////////////////
// frReportOptions - A set of properties, relating to the current
//                     report
//////////////////////////////////////////////////////////////////////

CLASS frReportOptions
   HIDDEN:
       VAR frManager, _SetAuthor, _SetCompressed, _SetCreateDate, _SetLastChange,;
           _SetDescription, _SetInitString, _SetName, _SetPassword, _SetVersion

       METHOD PrepareCalls
   EXPORTED:
       METHOD Init
       METHOD SetAuthor
       METHOD SetCompressed
       METHOD SetCreateDate
       METHOD SetLastChange
       METHOD SetDescription
       METHOD SetInitString
       METHOD SetName
       METHOD SetPassword
       METHOD SetVersion
ENDCLASS


////////////////////////////////////////////////////////////////////////
/////////////--start of frReportOptions class--/////////////////////////
////////////////////////////////////////////////////////////////////////
// Init()
////////////////////////////////////////////////////////////////////////

METHOD frReportOptions:Init(oManager)
   ::frManager := oManager
   ::PrepareCalls()
RETURN self


////////////////////////////////////////////////////////////////////////
// PrepareCalls()
////////////////////////////////////////////////////////////////////////

METHOD frReportOptions:PrepareCalls()

   ::_SetAuthor := DllPrepareCall(::frManager:frSystHandle, DLL_STDCALL, "SetAuthor")
#ifdef FR_WORKAROUND_DLL_BUG
    DllUnload(::frManager:frSystHandle)
#endif

   ::_SetCompressed := DllPrepareCall(::frManager:frSystHandle, DLL_STDCALL, "SetCompressed")
#ifdef FR_WORKAROUND_DLL_BUG
    DllUnload(::frManager:frSystHandle)
#endif

   ::_SetCreateDate := DllPrepareCall(::frManager:frSystHandle, DLL_STDCALL, "SetCreateDate")
#ifdef FR_WORKAROUND_DLL_BUG
    DllUnload(::frManager:frSystHandle)
#endif

   ::_SetLastChange := DllPrepareCall(::frManager:frSystHandle, DLL_STDCALL, "SetLastChange")
#ifdef FR_WORKAROUND_DLL_BUG
    DllUnload(::frManager:frSystHandle)
#endif

   ::_SetDescription := DllPrepareCall(::frManager:frSystHandle, DLL_STDCALL, "SetDescription")
#ifdef FR_WORKAROUND_DLL_BUG
    DllUnload(::frManager:frSystHandle)
#endif

   ::_SetInitString := DllPrepareCall(::frManager:frSystHandle, DLL_STDCALL, "SetInitString")
#ifdef FR_WORKAROUND_DLL_BUG
    DllUnload(::frManager:frSystHandle)
#endif

   ::_SetName := DllPrepareCall(::frManager:frSystHandle, DLL_STDCALL, "SetName")
#ifdef FR_WORKAROUND_DLL_BUG
    DllUnload(::frManager:frSystHandle)
#endif

   ::_SetPassword := DllPrepareCall(::frManager:frSystHandle, DLL_STDCALL, "SetPassword")
#ifdef FR_WORKAROUND_DLL_BUG
    DllUnload(::frManager:frSystHandle)
#endif

   ::_SetVersion := DllPrepareCall(::frManager:frSystHandle, DLL_STDCALL, "SetVersion")
#ifdef FR_WORKAROUND_DLL_BUG
    DllUnload(::frManager:frSystHandle)
#endif

RETURN



////////////////////////////////////////////////////////////////////////
// SetAuthor() - Set or get report author
////////////////////////////////////////////////////////////////////////

METHOD frReportOptions:SetAuthor(sAuthor) // ->OldValue
PRIVATE tmp_RetVal
   DllExecuteCall(::_SetAuthor, IF(sAuthor <> NIL, sAuthor, ""))
RETURN tmp_RetVal


////////////////////////////////////////////////////////////////////////
// SetCompressed() - Set or get report zip-compressed
////////////////////////////////////////////////////////////////////////

METHOD frReportOptions:SetCompressed(lCompressed) // ->OldValue
PRIVATE tmp_RetVal
   DllExecuteCall(::_SetCompressed, IF(lCompressed <> NIL, IF(lCompressed, 1, 0) , -1))
RETURN tmp_RetVal


////////////////////////////////////////////////////////////////////////
// SetCreateDate() - Set or get report creation date. Parameter must use
//                the current locale's date/time format. In the US, this
//                is commonly MM/DD/YY HH:MM:SS format, in Russia this
//                is DD.MM.YYYY HH:MM:SS. Specifying AM or PM as part of
//                the time is optional, as are the seconds. Use 24-hour
//                time (7:45 PM is entered as 19:45, for example) if AM
//                or PM is not specified.
////////////////////////////////////////////////////////////////////////

METHOD frReportOptions:SetCreateDate(sDateTime) // ->OldValue
PRIVATE tmp_RetVal
   DllExecuteCall(::_SetCreateDate, IF(sDateTime<>NIL, sDateTime, ""))
RETURN tmp_RetVal


//////////////////////////////////////////////////////////////////////////
// SetLastChange() - Set or get last change date. Parameter is the same as
//                   in SetCreateDate()
//////////////////////////////////////////////////////////////////////////

METHOD frReportOptions:SetLastChange(sDateTime) // ->OldValue
PRIVATE tmp_RetVal
   DllExecuteCall(::_SetLastChange, IF(sDateTime<>NIL, sDateTime, ""))
RETURN tmp_RetVal


//////////////////////////////////////////////////////////////////////////
// SetDescription() - Set or get report description.
//////////////////////////////////////////////////////////////////////////

METHOD frReportOptions:SetDescription(sDescription) // ->OldValue
PRIVATE tmp_RetVal
   DllExecuteCall(::_SetDescription, IF(sDescription<>NIL, sDescription, ""))
RETURN tmp_RetVal


//////////////////////////////////////////////////////////////////////////
// SetInitString() - Set or get report init string for dot-matrix reports
//////////////////////////////////////////////////////////////////////////

METHOD frReportOptions:SetInitString(sInitString) // ->OldValue
PRIVATE tmp_RetVal
   DllExecuteCall(::_SetInitString, IF(sInitString<>NIL, sInitString, ""))
RETURN tmp_RetVal


//////////////////////////////////////////////////////////////////////////
// SetName() - Set or get report name.
//////////////////////////////////////////////////////////////////////////

METHOD frReportOptions:SetName(sName) // ->OldValue
PRIVATE tmp_RetVal
   DllExecuteCall(::_SetName, IF(sName<>NIL, sName, ""))
RETURN tmp_RetVal


//////////////////////////////////////////////////////////////////////////
// SetPassword() - Set or get report password. If password is not blank,
//                 a password is required when opening a report
//////////////////////////////////////////////////////////////////////////

METHOD frReportOptions:SetPassword(sPassword) // ->OldValue
PRIVATE tmp_RetVal
   DllExecuteCall(::_SetPassword, IF(sPassword<>NIL, sPassword, ""))
RETURN tmp_RetVal


//////////////////////////////////////////////////////////////////////////
// SetVersion() - Set or get report version. version consist of :
//
//                 {sVersionMajor,
//                  sVersionMinor,
//                  sVersionRelease,
//                  sVersionBuild}
//
//////////////////////////////////////////////////////////////////////////

METHOD frReportOptions:SetVersion(aVersion) // ->OldValue
PRIVATE tmp_Param := aVersion
  IF (tmp_Param = NIL)
    tmp_Param := {NIL, NIL, NIL, NIL}
  ENDIF
  IF (Len(tmp_Param) < 4)
    ASize(tmp_Param, 4)
  ENDIF
  DllExecuteCall(::_SetVersion)
RETURN tmp_Param


/////////////--end of frReportOptions class--////////////////////////////


////////////////////////////////////////////////////////////////////////
/////////////--start of frEngineOptions class--/////////////////////////
////////////////////////////////////////////////////////////////////////
// Init()
////////////////////////////////////////////////////////////////////////

METHOD frEngineOptions:Init(oManager)
   ::frManager := oManager
   ::PrepareCalls()
RETURN self


////////////////////////////////////////////////////////////////////////
// PrepareCalls()
////////////////////////////////////////////////////////////////////////

METHOD frEngineOptions:PrepareCalls()

   ::_SetConvertNulls := DllPrepareCall(::frManager:frSystHandle, DLL_STDCALL, "SetConvertNulls")
#ifdef FR_WORKAROUND_DLL_BUG
    DllUnload(::frManager:frSystHandle)
#endif

   ::_SetDoublePass := DllPrepareCall(::frManager:frSystHandle, DLL_STDCALL, "SetDoublePass")
#ifdef FR_WORKAROUND_DLL_BUG
    DllUnload(::frManager:frSystHandle)
#endif

   ::_SetPrintIfEmpty := DllPrepareCall(::frManager:frSystHandle, DLL_STDCALL, "SetPrintIfEmpty")
#ifdef FR_WORKAROUND_DLL_BUG
    DllUnload(::frManager:frSystHandle)
#endif

   ::_SetSilentMode := DllPrepareCall(::frManager:frSystHandle, DLL_STDCALL, "SetSilentMode")
#ifdef FR_WORKAROUND_DLL_BUG
    DllUnload(::frManager:frSystHandle)
#endif

   ::_SetNewSilentMode := DllPrepareCall(::frManager:frSystHandle, DLL_STDCALL, "SetNewSilentMode")
#ifdef FR_WORKAROUND_DLL_BUG
    DllUnload(::frManager:frSystHandle)
#endif

   ::_SetMaxMemSize := DllPrepareCall(::frManager:frSystHandle, DLL_STDCALL, "SetMaxMemSize")
#ifdef FR_WORKAROUND_DLL_BUG
    DllUnload(::frManager:frSystHandle)
#endif

   ::_SetTempDir := DllPrepareCall(::frManager:frSystHandle, DLL_STDCALL, "SetTempDir")
#ifdef FR_WORKAROUND_DLL_BUG
    DllUnload(::frManager:frSystHandle)
#endif

   ::_SetUseFileCache := DllPrepareCall(::frManager:frSystHandle, DLL_STDCALL, "SetUseFileCache")
#ifdef FR_WORKAROUND_DLL_BUG
    DllUnload(::frManager:frSystHandle)
#endif

RETURN


////////////////////////////////////////////////////////////////////////
// SetConvertNulls() - Converts the "Null" value of the DB field into
//                    "0", "False," or empty string, depending on the
//                    field type.   Default - True
////////////////////////////////////////////////////////////////////////

METHOD frEngineOptions:SetConvertNulls(lConvert)
  DllExecuteCall(::_SetConvertNulls, IF(lConvert <> NIL, IF(lConvert, 1, 0) , 1))
RETURN self


////////////////////////////////////////////////////////////////////////
// SetDoublePass() - Makes a report a two-pass one. Default - False
////////////////////////////////////////////////////////////////////////

METHOD frEngineOptions:SetDoublePass(lDouble)
  DllExecuteCall(::_SetDoublePass, IF(lDouble <> NIL, IF(lDouble, 1, 0) , 0))
RETURN self


////////////////////////////////////////////////////////////////////////
// SetPrintIfEmpty() - Defines, whether it is necessary to print a blank
//                     report (one which containing no data lines).
////////////////////////////////////////////////////////////////////////

METHOD frEngineOptions:SetPrintIfEmpty(lPrint)
  DllExecuteCall(::_SetPrintIfEmpty, IF(lPrint <> NIL, IF(lPrint, 1, 0) , 1))
RETURN self


////////////////////////////////////////////////////////////////////////
// SetSilentMode() - "Silent" mode. Thus all messages about errors are
//                   stored in the Errors property, without displaying
//                   any messages on the screen. Default - False
////////////////////////////////////////////////////////////////////////

METHOD frEngineOptions:SetSilentMode(lSilent)
  DllExecuteCall(::_SetSilentMode, IF(lSilent <> NIL, IF(lSilent, 1, 0) , 0))
RETURN self


////////////////////////////////////////////////////////////////////////
// SetNewSilentMode() - The following values are available:
//                      FR_SIM_MESSAGEBOXES (0)
//                      FR_SIM_RETHROW      (1)
//                      FR_SIM_SILENT       (2)
////////////////////////////////////////////////////////////////////////

METHOD frEngineOptions:SetNewSilentMode(nMode)
  DllExecuteCall(::_SetNewSilentMode, nMode)
RETURN


////////////////////////////////////////////////////////////////////////
// SetMaxMemSize() - The maximum size of memory in Mbytes, allocated to
//                   the report pages' cache. It becomes useful in cases
//                   when the "UseFileCashe" property is equal to True.
//                   If a report begins to occupy more memory during
//                   construction, caching of the constructed report
//                   pages into a temporary file is performed. This
//                   property is inexact and allows only approximate
//                   determination of the memory limit. Default - 10
////////////////////////////////////////////////////////////////////////

METHOD frEngineOptions:SetMaxMemSize(nSize)
   DllExecuteCall(::_SetMaxMemSize, nSize)
RETURN self


////////////////////////////////////////////////////////////////////////
// SetTempDir() - Specifies a path to the directory for storing
//                temporary files
////////////////////////////////////////////////////////////////////////

METHOD frEngineOptions:SetTempDir(sDir) //->OldValue
PRIVATE tmp_RetVal
   DllExecuteCall(::_SetTempDir, IF(sDir <> NIL, sDir, ""))
RETURN tmp_RetVal


////////////////////////////////////////////////////////////////////////
// SetUseFileCache() - Defines, whether it is necessary to use report
//                     pages caching into the file.
////////////////////////////////////////////////////////////////////////

METHOD frEngineOptions:SetUseFileCache(lUse)
   DllExecuteCall(::_SetUseFileCache, IF(lUse <> NIL, IF(lUse, 1, 0) , 0))
RETURN self


/////////////--end of frEngineOptions class--////////////////////////////


////////////////////////////////////////////////////////////////////////
/////////////--start of frPreviewOptions class--////////////////////////
////////////////////////////////////////////////////////////////////////
// Init()
////////////////////////////////////////////////////////////////////////

METHOD frPreviewOptions:Init(oManager)
   ::frManager := oManager
   ::PrepareCalls()
RETURN self


////////////////////////////////////////////////////////////////////////
// PrepareCalls()
////////////////////////////////////////////////////////////////////////

METHOD frPreviewOptions:PrepareCalls()

   ::_SetAllowEdit := DllPrepareCall(::frManager:frSystHandle, DLL_STDCALL, "SetAllowEdit")
#ifdef FR_WORKAROUND_DLL_BUG
    DllUnload(::frManager:frSystHandle)
#endif

   ::_SetButtons := DllPrepareCall(::frManager:frSystHandle, DLL_STDCALL, "SetButtons")
#ifdef FR_WORKAROUND_DLL_BUG
    DllUnload(::frManager:frSystHandle)
#endif

   ::_SetDoubleBuffered := DllPrepareCall(::frManager:frSystHandle, DLL_STDCALL, "SetDoubleBuffered")
#ifdef FR_WORKAROUND_DLL_BUG
    DllUnload(::frManager:frSystHandle)
#endif

   ::_SetMaximized := DllPrepareCall(::frManager:frSystHandle, DLL_STDCALL, "SetMaximized")
#ifdef FR_WORKAROUND_DLL_BUG
    DllUnload(::frManager:frSystHandle)
#endif

   ::_SetBounds := DllPrepareCall(::frManager:frSystHandle, DLL_STDCALL, "SetBounds")
#ifdef FR_WORKAROUND_DLL_BUG
    DllUnload(::frManager:frSystHandle)
#endif

   ::_SetOutlineVisible := DllPrepareCall(::frManager:frSystHandle, DLL_STDCALL, "SetOutlineVisible")
#ifdef FR_WORKAROUND_DLL_BUG
    DllUnload(::frManager:frSystHandle)
#endif

   ::_SetOutlineExpand := DllPrepareCall(::frManager:frSystHandle, DLL_STDCALL, "SetOutlineExpand")
#ifdef FR_WORKAROUND_DLL_BUG
    DllUnload(::frManager:frSystHandle)
#endif

   ::_SetOutlineWidth := DllPrepareCall(::frManager:frSystHandle, DLL_STDCALL, "SetOutlineWidth")
#ifdef FR_WORKAROUND_DLL_BUG
    DllUnload(::frManager:frSystHandle)
#endif

   ::_SetShowCaptions := DllPrepareCall(::frManager:frSystHandle, DLL_STDCALL, "SetShowCaptions")
#ifdef FR_WORKAROUND_DLL_BUG
    DllUnload(::frManager:frSystHandle)
#endif

   ::_SetZoom := DllPrepareCall(::frManager:frSystHandle, DLL_STDCALL, "SetZoom")
#ifdef FR_WORKAROUND_DLL_BUG
    DllUnload(::frManager:frSystHandle)
#endif

   ::_SetZoomMode := DllPrepareCall(::frManager:frSystHandle, DLL_STDCALL, "SetZoomMode")
#ifdef FR_WORKAROUND_DLL_BUG
    DllUnload(::frManager:frSystHandle)
#endif

   ::_SetPictureCacheInFile := DllPrepareCall(::frManager:frSystHandle, DLL_STDCALL, "SetPictureCacheInFile")
#ifdef FR_WORKAROUND_DLL_BUG
    DllUnload(::frManager:frSystHandle)
#endif


RETURN


//////////////////////////////////////////////////////////////////////
// SetAllowEdit() - Enables or disables a finished report editing.
//                  Default - True
//////////////////////////////////////////////////////////////////////

METHOD frPreviewOptions:SetAllowEdit(lAllow)
   DllExecuteCall(::_SetAllowEdit, IF(lAllow <> NIL, IF(lAllow, 1, 0) , 1))
RETURN self


/////////////////////////////////////////////////////////////////////////
// SetButtons() -   A set of buttons, which will be available in the
//                  preview window.
//                  nButtons - is sum of FR_PB_XXX values. See fastrep.ch
//                  Default - All buttons.
//////////////////////////////////////////////////////////////////////////

METHOD frPreviewOptions:SetButtons(nButtons)
   nButtons := IF(nButtons <> NIL, nButtons, 0)
   DllExecuteCall(::_SetButtons, nButtons)
RETURN self


//////////////////////////////////////////////////////////////////////
// SetDoubleBuffered() - A double-buffer mode for the preview window.
//                       If enabled (by default), the preview window
//                       will not flicker during repainting, but the
//                       process speed would be reduced.
//////////////////////////////////////////////////////////////////////

METHOD frPreviewOptions:SetDoubleBuffered(lDouble)
   DllExecuteCall(::_SetDoubleBuffered, IF(lDouble <> NIL, IF(lDouble, 1, 0) , 1))
RETURN self


////////////////////////////////////////////////////////////////////////
// SetMaximized() - Defines whether the preview window is maximized
////////////////////////////////////////////////////////////////////////

METHOD frPreviewOptions:SetMaximized(lMax)
   DllExecuteCall(::_SetMaximized, IF(lMax <> NIL, IF(lMax, 1, 0) , 1))
RETURN self


////////////////////////////////////////////////////////////////////////
// SetBounds() - Defines position and size of the preview window
////////////////////////////////////////////////////////////////////////

METHOD frPreviewOptions:SetBounds(nLeft, nTop, nWidth, nHeight)
   DllExecuteCall(::_SetBounds, nLeft, nTop, nWidth, nHeight)
RETURN self


////////////////////////////////////////////////////////////////////////
// SetOutlineVisible() - Defines whether the panel with the report
//                       outline is visible.
////////////////////////////////////////////////////////////////////////

METHOD frPreviewOptions:SetOutlineVisible(lVis)
   DllExecuteCall(::_SetOutlineVisible, IF(lVis <> NIL, IF(lVis, 1, 0) , 0))
RETURN self


////////////////////////////////////////////////////////////////////////
// SetOutlineExpand() - Defines whether the tree of the report
//                      outline is expand.
////////////////////////////////////////////////////////////////////////

METHOD frPreviewOptions:SetOutlineExpand(lExpand)
   DllExecuteCall(::_SetOutlineExpand, IF(lExpand <> NIL, IF(lExpand, 1, 0) , 1))
RETURN self


//////////////////////////////////////////////////////////////////////////
// SetOutlineWidth() - Defines width of the panel with the report outline.
//////////////////////////////////////////////////////////////////////////

METHOD frPreviewOptions:SetOutlineWidth(nWidth)
   DllExecuteCall(::_SetOutlineWidth, IF(nWidth <> NIL, nWidth , 120))
RETURN self


//////////////////////////////////////////////////////////////////////////
// SetShowCaptions() - Defines whether it is necessary to display button
//                     captions. When enabling this property, you should
//                     limit the number of the displayed buttons with
//                     SetButtons() function, since all the buttons would not
//                     find room on the screen.
//////////////////////////////////////////////////////////////////////////

METHOD frPreviewOptions:SetShowCaptions(lShow)
   DllExecuteCall(::_SetShowCaptions, IF(lShow <> NIL, IF(lShow, 1, 0) , 0))
RETURN self


////////////////////////////////////////////////////////////////////////
// SetZoom()-Set default zooming, for example 1.4, Default - 1
////////////////////////////////////////////////////////////////////////

METHOD frPreviewOptions:SetZoom(nZoom) //->OldValue
PRIVATE tmp_Param := nZoom
   DllExecuteCall(::_SetZoom, IF(nZoom <> NIL, nZoom , 0))
RETURN tmp_Param


////////////////////////////////////////////////////////////////////////
// SetZoomMode()- Set default zooming mode. The following values are
//                available:
//                     FR_ZM_DEFAULT        0
//                     FR_ZM_WHOLEPAGE      1
//                     FR_ZM_PAGEWIDTH      2
//                     FR_ZM_MANYPAGES      3
//                       Default - FR_ZM_DEFAULT
////////////////////////////////////////////////////////////////////////

METHOD frPreviewOptions:SetZoomMode(nZMode) //->OldValue
RETURN DllExecuteCall(::_SetZoomMode, IF(nZMode <> NIL, nZMode, -1))


////////////////////////////////////////////////////////////////////////
//
//  SetPictureCacheInFile() - Cache pictures or not, default - true.
//
////////////////////////////////////////////////////////////////////////

METHOD frPreviewOptions:SetPictureCacheInFile(lCache)
   DllExecuteCall(::_SetPictureCacheInFile, IF(lCache <> NIL, IF(lCache, 1, 0) , 0))
RETURN self


/////////////--end of frPreviewOptions class--//////////////////////////


////////////////////////////////////////////////////////////////////////
/////////////--start of frPrintOptions class--//////////////////////////
////////////////////////////////////////////////////////////////////////
// Init()
////////////////////////////////////////////////////////////////////////

METHOD frPrintOptions:Init(oManager)
   ::frManager := oManager
   ::PrepareCalls()
RETURN self


////////////////////////////////////////////////////////////////////////
// PrepareCalls()
////////////////////////////////////////////////////////////////////////

METHOD frPrintOptions:PrepareCalls()

   ::_SetCopies := DllPrepareCall(::frManager:frSystHandle, DLL_STDCALL, "SetCopies")
#ifdef FR_WORKAROUND_DLL_BUG
    DllUnload(::frManager:frSystHandle)
#endif

   ::_SetCollate := DllPrepareCall(::frManager:frSystHandle, DLL_STDCALL, "SetCollate")
#ifdef FR_WORKAROUND_DLL_BUG
    DllUnload(::frManager:frSystHandle)
#endif

   ::_SetPageNumbers := DllPrepareCall(::frManager:frSystHandle, DLL_STDCALL, "SetPageNumbers")
#ifdef FR_WORKAROUND_DLL_BUG
    DllUnload(::frManager:frSystHandle)
#endif

   ::_SetPrinter := DllPrepareCall(::frManager:frSystHandle, DLL_STDCALL, "SetPrinter")
#ifdef FR_WORKAROUND_DLL_BUG
    DllUnload(::frManager:frSystHandle)
#endif

   ::_SetPrintPages := DllPrepareCall(::frManager:frSystHandle, DLL_STDCALL, "SetPrintPages")
#ifdef FR_WORKAROUND_DLL_BUG
    DllUnload(::frManager:frSystHandle)
#endif

   ::_SetShowDialog := DllPrepareCall(::frManager:frSystHandle, DLL_STDCALL, "SetShowDialog")
#ifdef FR_WORKAROUND_DLL_BUG
    DllUnload(::frManager:frSystHandle)
#endif

   ::_SetReverse := DllPrepareCall(::frManager:frSystHandle, DLL_STDCALL, "SetReverse")
#ifdef FR_WORKAROUND_DLL_BUG
    DllUnload(::frManager:frSystHandle)
#endif

   ::_ClearOptions := DllPrepareCall(::frManager:frSystHandle, DLL_STDCALL, "ClearOptions")
#ifdef FR_WORKAROUND_DLL_BUG
    DllUnload(::frManager:frSystHandle)
#endif

RETURN


////////////////////////////////////////////////////////////////////////
// SetCopies - A number of the printable copies by default. default - 1
////////////////////////////////////////////////////////////////////////

METHOD frPrintOptions:SetCopies(nCopies) // ->OldValue
RETURN DllExecuteCall(::_SetCopies, IF(nCopies <> NIL, nCopies, -1))


//////////////////////////////////////////////////////////////////////
// SetCollate - whether to collate the copies. Default - True
//////////////////////////////////////////////////////////////////////

METHOD frPrintOptions:SetCollate(lCollate) // ->OldValue
   lCollate := IF(lCollate <> NIL, IF(lCollate, 1, 0), 2)
RETURN IF(DllExecuteCall(::_SetCollate, lCollate) = 1, .t., .f.)


//////////////////////////////////////////////////////////////////////
// SetPageNumbers - Page numbers, which are to be printed.
//                  For example, "1,3,5-12,17-". default - ""
//////////////////////////////////////////////////////////////////////

METHOD frPrintOptions:SetPageNumbers(sParam) // ->OldValue
PRIVATE tmp_RetVal := ""
   DllExecuteCall(::_SetPageNumbers, IF(sParam <> NIL, 1, 0),IF(sParam <> NIL, sParam, ""))
RETURN tmp_RetVal


//////////////////////////////////////////////////////////////////////
// SetPrinter - Get or set printer name. Default - default printer
//////////////////////////////////////////////////////////////////////

METHOD frPrintOptions:SetPrinter(sPrinter) // ->OldValue
PRIVATE tmp_RetVal := ""
   DllExecuteCall(::_SetPrinter, IF(sPrinter <> NIL, 1, 0),IF(sPrinter <> NIL, sPrinter, ""))
RETURN tmp_RetVal


//////////////////////////////////////////////////////////////////////
// SetPrintPages - Defines the pages to be printed.
//                 The following values are available (look FastRep.ch):
//                 FR_PP_ALL  - all  (Value - 0)
//                 FR_PP_ODD  - odd  (Value - 1)
//                 FR_PP_EVEN - even (Value - 2)
//                   default - FR_PP_ALL
//////////////////////////////////////////////////////////////////////

METHOD frPrintOptions:SetPrintPages(nPages) // ->OldValue
RETURN DllExecuteCall(::_SetPrintPages, IF(nPages <> NIL, nPages, -1))


//////////////////////////////////////////////////////////////////////
// SetShowDialog - Whether to display a print dialog. Default - True
//////////////////////////////////////////////////////////////////////

METHOD frPrintOptions:SetShowDialog(lShow) // ->OldValue
   lShow := IF(lShow <> NIL, IF(lShow, 1, 0), 2)
RETURN IF(DllExecuteCall(::_SetShowDialog, lShow) = 1, .t., .f.)


//////////////////////////////////////////////////////////////////////
//  SetReverse - get or set reports reverse. Default - False
//////////////////////////////////////////////////////////////////////

METHOD frPrintOptions:SetReverse(lReverse) // ->OldValue
   lReverse := IF(lReverse <> NIL, IF(lReverse, 1, 0), 2)
RETURN IF(DllExecuteCall(::_SetReverse, lReverse) = 1, .t., .f.)


//////////////////////////////////////////////////////////////////////
//  ClearOptions - set all options to default values
//////////////////////////////////////////////////////////////////////

METHOD frPrintOptions:ClearOptions()
   DllExecuteCall(::_ClearOptions)
RETURN self

/////////////--end of frPrintOptions class--////////////////////////////


////////////////////////////////////////////////////////////////////////
/////////////--start of frReportManager class--/////////////////////////
////////////////////////////////////////////////////////////////////////
//  Init()
////////////////////////////////////////////////////////////////////////

METHOD frReportManager:Init(cOptionalPath)
 ***  cOptionalPath := IF(cOptionalPath <> NIL, cOptionalPath, "FRSyst.dll")
      cOptionalPath := IF(cOptionalPath <> NIL, cOptionalPath, gde_exe()+"\"+"CSYSTEMS9.DLL")
   ::frSystHandle := DllLoad(cOptionalPath)
   IF ::frSystHandle <> 0
      ::PrepareCalls()
      DllExecuteCall(::_InitSyst)
      ::PrintOptions := frPrintOptions():New( self )
      ::PreviewOptions := frPreviewOptions():New( self )
      ::EngineOptions := frEngineOptions():New( self )
      ::ReportOptions := frReportOptions():New( self )
   ELSE

      *** MsgBox(DosErrorMessage()) // The specified module could not be found

     MsgBox(;
            "Nema report fajla: CSYSTEMS9.DLL  "   +chr(13)+;
            "-------------------------------------"+chr(13)+;
            "Error: "+alltrim(str(DosError()))     +chr(13)+;
            "Proc:  "+Procname()                   +chr(13)+;
            "Line:  "+alltrim(str(ProcLine()))     +chr(13)+;
            "  ",;
            "File not found")
             IF Type("oSession")=="O"
               // disconnect from ADS: PUBLIC oSession
                  oSession:disconnect()
             ENDIF
             QUIT
            // mora da postoji prethodna provera CSYSTEMS9.DLL
            // na startu aplikacije da ne bi ovde bio QUIT
   ENDIF
RETURN self


////////////////////////////////////////////////////////////////////////
//  PrepareCalls()
////////////////////////////////////////////////////////////////////////

METHOD frReportManager:PrepareCalls()

   ::_InitSyst := DllPrepareCall(::frSystHandle, DLL_STDCALL, "InitSyst")
#ifdef FR_WORKAROUND_DLL_BUG
    DllUnload(::frSystHandle)
#endif

   ::_FrNotifyError := DllPrepareCall(::frSystHandle, DLL_STDCALL, "FrNotifyError")
#ifdef FR_WORKAROUND_DLL_BUG
    DllUnload(::frSystHandle)
#endif

   ::_CloseSyst := DllPrepareCall(::frSystHandle, DLL_STDCALL, "CloseSyst")
#ifdef FR_WORKAROUND_DLL_BUG
    DllUnload(::frSystHandle)
#endif

   ::_SetIcon := DllPrepareCall(::frSystHandle, DLL_STDCALL, "SetIcon")
#ifdef FR_WORKAROUND_DLL_BUG
    DllUnload(::frSystHandle)
#endif

   ::_SetTitle := DllPrepareCall(::frSystHandle, DLL_STDCALL, "SetTitle")
#ifdef FR_WORKAROUND_DLL_BUG
    DllUnload(::frSystHandle)
#endif

   ::_SetVisualActions := DllPrepareCall(::frSystHandle, DLL_STDCALL, "SetVisualActions")
#ifdef FR_WORKAROUND_DLL_BUG
    DllUnload(::frSystHandle)
#endif

   ::_LoadLangRes := DllPrepareCall(::frSystHandle, DLL_STDCALL, "LoadLangRes")
#ifdef FR_WORKAROUND_DLL_BUG
    DllUnload(::frSystHandle)
#endif

   ::_ShowReport := DllPrepareCall(::frSystHandle, DLL_STDCALL, "ShowReport")
#ifdef FR_WORKAROUND_DLL_BUG
    DllUnload(::frSystHandle)
#endif

   ::_PrepareReport := DllPrepareCall(::frSystHandle, DLL_STDCALL, "PrepareReport")
#ifdef FR_WORKAROUND_DLL_BUG
    DllUnload(::frSystHandle)
#endif

   ::_ShowPreparedReport := DllPrepareCall(::frSystHandle, DLL_STDCALL, "ShowPreparedReport")
#ifdef FR_WORKAROUND_DLL_BUG
    DllUnload(::frSystHandle)
#endif

   ::_DesignReport := DllPrepareCall(::frSystHandle, DLL_STDCALL, "DesignReport")
#ifdef FR_WORKAROUND_DLL_BUG
    DllUnload(::frSystHandle)
#endif

   ::_LoadFromFile := DllPrepareCall(::frSystHandle, DLL_STDCALL, "LoadFromFile")
#ifdef FR_WORKAROUND_DLL_BUG
    DllUnload(::frSystHandle)
#endif

   ::_LoadFromResource := DllPrepareCall(::frSystHandle, DLL_STDCALL, "LoadFromResource")
#ifdef FR_WORKAROUND_DLL_BUG
    DllUnload(::frSystHandle)
#endif

   ::_LoadFromBlob := DllPrepareCall(::frSystHandle, DLL_STDCALL, "LoadFromBlob")
#ifdef FR_WORKAROUND_DLL_BUG
    DllUnload(::frSystHandle)
#endif

   ::_SaveToFile := DllPrepareCall(::frSystHandle, DLL_STDCALL, "SaveToFile")
#ifdef FR_WORKAROUND_DLL_BUG
    DllUnload(::frSystHandle)
#endif

   ::_SaveToBlob := DllPrepareCall(::frSystHandle, DLL_STDCALL, "SaveToBlob")
#ifdef FR_WORKAROUND_DLL_BUG
    DllUnload(::frSystHandle)
#endif

   ::_Clear := DllPrepareCall(::frSystHandle, DLL_STDCALL, "Clear")
#ifdef FR_WORKAROUND_DLL_BUG
    DllUnload(::frSystHandle)
#endif

   ::_LoadStyleSheet := DllPrepareCall(::frSystHandle, DLL_STDCALL, "LoadStyleSheet")
#ifdef FR_WORKAROUND_DLL_BUG
    DllUnload(::frSystHandle)
#endif

   ::_Print := DllPrepareCall(::frSystHandle, DLL_STDCALL, "Print")
#ifdef FR_WORKAROUND_DLL_BUG
    DllUnload(::frSystHandle)
#endif

   ::_GetErrors := DllPrepareCall(::frSystHandle, DLL_STDCALL, "GetErrors")
#ifdef FR_WORKAROUND_DLL_BUG
    DllUnload(::frSystHandle)
#endif

   ::_DoExport := DllPrepareCall(::frSystHandle, DLL_STDCALL, "DoExport")
#ifdef FR_WORKAROUND_DLL_BUG
    DllUnload(::frSystHandle)
#endif

   ::_GetProperty := DllPrepareCall(::frSystHandle, DLL_STDCALL, "GetProperty")
#ifdef FR_WORKAROUND_DLL_BUG
    DllUnload(::frSystHandle)
#endif

   ::_SetProperty := DllPrepareCall(::frSystHandle, DLL_STDCALL, "SetProperty")
#ifdef FR_WORKAROUND_DLL_BUG
    DllUnload(::frSystHandle)
#endif

   ::_SetEventHandler := DllPrepareCall(::frSystHandle, DLL_STDCALL, "SetEventHandler")
#ifdef FR_WORKAROUND_DLL_BUG
    DllUnload(::frSystHandle)
#endif

   ::_AddFunction := DllPrepareCall(::frSystHandle, DLL_STDCALL, "AddFunction")
#ifdef FR_WORKAROUND_DLL_BUG
    DllUnload(::frSystHandle)
#endif

   ::_AddVariable := DllPrepareCall(::frSystHandle, DLL_STDCALL, "AddVariable")
#ifdef FR_WORKAROUND_DLL_BUG
    DllUnload(::frSystHandle)
#endif

   ::_SetVariable := DllPrepareCall(::frSystHandle, DLL_STDCALL, "SetVariable")
#ifdef FR_WORKAROUND_DLL_BUG
    DllUnload(::frSystHandle)
#endif

   ::_GetVariable := DllPrepareCall(::frSystHandle, DLL_STDCALL, "GetVariable")
#ifdef FR_WORKAROUND_DLL_BUG
    DllUnload(::frSystHandle)
#endif

   ::_DeletVariable := DllPrepareCall(::frSystHandle, DLL_STDCALL, "DeletVariable")
#ifdef FR_WORKAROUND_DLL_BUG
    DllUnload(::frSystHandle)
#endif

   ::_DeletCategory := DllPrepareCall(::frSystHandle, DLL_STDCALL, "DeletCategory")
#ifdef FR_WORKAROUND_DLL_BUG
    DllUnload(::frSystHandle)
#endif

   ::_SetScriptVar := DllPrepareCall(::frSystHandle, DLL_STDCALL, "SetScriptVar")
#ifdef FR_WORKAROUND_DLL_BUG
    DllUnload(::frSystHandle)
#endif

   ::_GetScriptVar := DllPrepareCall(::frSystHandle, DLL_STDCALL, "GetScriptVar")
#ifdef FR_WORKAROUND_DLL_BUG
    DllUnload(::frSystHandle)
#endif

   ::_Calc := DllPrepareCall(::frSystHandle, DLL_STDCALL, "Calc")
#ifdef FR_WORKAROUND_DLL_BUG
    DllUnload(::frSystHandle)
#endif

   ::_SetWorkArea := DllPrepareCall(::frSystHandle, DLL_STDCALL, "SetWorkArea")
#ifdef FR_WORKAROUND_DLL_BUG
   DllUnload(::frSystHandle)
#endif

   ::_SetMasterDetail := DllPrepareCall(::frSystHandle, DLL_STDCALL, "SetMasterDetail")
#ifdef FR_WORKAROUND_DLL_BUG
   DllUnload(::frSystHandle)
#endif

   ::_SetResyncPair := DllPrepareCall(::frSystHandle, DLL_STDCALL, "SetResyncPair")
#ifdef FR_WORKAROUND_DLL_BUG
   DllUnload(::frSystHandle)
#endif

   ::_SetUserDataSet := DllPrepareCall(::frSystHandle, DLL_STDCALL, "SetUserDataSet")
#ifdef FR_WORKAROUND_DLL_BUG
   DllUnload(::frSystHandle)
#endif

   ::_Resync := DllPrepareCall(::frSystHandle, DLL_STDCALL, "Resync")
#ifdef FR_WORKAROUND_DLL_BUG
   DllUnload(::frSystHandle)
#endif

   ::_SetFieldAliases := DllPrepareCall(::frSystHandle, DLL_STDCALL, "SetFieldAliases")
#ifdef FR_WORKAROUND_DLL_BUG
   DllUnload(::frSystHandle)
#endif

   ::_RemoveDataSet := DllPrepareCall(::frSystHandle, DLL_STDCALL, "RemoveDataSet")
#ifdef FR_WORKAROUND_DLL_BUG
   DllUnload(::frSystHandle)
#endif

   ::_ClearDataSets := DllPrepareCall(::frSystHandle, DLL_STDCALL, "ClearDataSets")
#ifdef FR_WORKAROUND_DLL_BUG
   DllUnload(::frSystHandle)
#endif

   ::_ClearMasterDetail := DllPrepareCall(::frSystHandle, DLL_STDCALL, "ClearMasterDetail")
#ifdef FR_WORKAROUND_DLL_BUG
   DllUnload(::frSystHandle)
#endif

   ::_ClearResyncPair := DllPrepareCall(::frSystHandle, DLL_STDCALL, "ClearResyncPair")
#ifdef FR_WORKAROUND_DLL_BUG
   DllUnload(::frSystHandle)
#endif

   ::_SetADOConnectStr := DllPrepareCall(::frSystHandle, DLL_STDCALL, "SetADOConnectStr")
#ifdef FR_WORKAROUND_DLL_BUG
   DllUnload(::frSystHandle)
#endif

   ::_SetADOConnectPartStr := DllPrepareCall(::frSystHandle, DLL_STDCALL, "SetADOConnectPartStr")
#ifdef FR_WORKAROUND_DLL_BUG
   DllUnload(::frSystHandle)
#endif

   ::_StartManualBuild := DllPrepareCall(::frSystHandle, DLL_STDCALL, "StartManualBuild")
#ifdef FR_WORKAROUND_DLL_BUG
   DllUnload(::frSystHandle)
#endif

   ::_MemoAt := DllPrepareCall(::frSystHandle, DLL_STDCALL, "MemoAt")
#ifdef FR_WORKAROUND_DLL_BUG
   DllUnload(::frSystHandle)
#endif

  ::_SetDefaultFontProperty := DllPrepareCall(::frSystHandle, DLL_STDCALL, "SetDefaultFontProperty")
#ifdef FR_WORKAROUND_DLL_BUG
   DllUnload(::frSystHandle)
#endif

  ::_NewPage := DllPrepareCall(::frSystHandle, DLL_STDCALL, "NewPage")
#ifdef FR_WORKAROUND_DLL_BUG
   DllUnload(::frSystHandle)
#endif

  ::_SetManualObjProperty := DllPrepareCall(::frSystHandle, DLL_STDCALL, "SetManualObjProperty")
#ifdef FR_WORKAROUND_DLL_BUG
   DllUnload(::frSystHandle)
#endif

   ::_LineAt := DllPrepareCall(::frSystHandle, DLL_STDCALL, "LineAt")
#ifdef FR_WORKAROUND_DLL_BUG
   DllUnload(::frSystHandle)
#endif

   ::_PictureAt := DllPrepareCall(::frSystHandle, DLL_STDCALL, "PictureAt")
#ifdef FR_WORKAROUND_DLL_BUG
   DllUnload(::frSystHandle)
#endif

   ::_SendMail := DllPrepareCall(::frSystHandle, DLL_STDCALL, "SendMail")
#ifdef FR_WORKAROUND_DLL_BUG
   DllUnload(::frSystHandle)
#endif


RETURN

////////////////////////////////////////////////////////////////////////
//  FrNotifyError() - technical method to notify FR about runtime error
////////////////////////////////////////////////////////////////////////

METHOD frReportManager:FrNotifyError(oError)
    DllExecuteCall(::_FrNotifyError)
RETURN Eval(::bSaveError, oError)


////////////////////////////////////////////////////////////////////////
//  DestroyFR() - destroy all FastReport objects and unload "FRsyst.dll"
////////////////////////////////////////////////////////////////////////

METHOD frReportManager:DestroyFR()
   ::PrintOptions := NIL
   ::PreviewOptions := NIL
   ::EngineOptions := NIL
   ::ReportOptions := NIL
   DllExecuteCall(::_CloseSyst)
   DllUnLoad(::frSystHandle)
   ::frSystHandle := 0
RETURN self


///////////////////////////////////////////////////////////////////////////
//  SetIcon() -  the numeric resource ID or NAME of the icon
//               of FastReport-windows.
///////////////////////////////////////////////////////////////////////////

METHOD frReportManager:SetIcon(xValue)
LOCAL lRes
   IF ValType(xValue) = "C"
      lRes := DllExecuteCall(::_SetIcon, 0, xValue) == 1
   ELSE
      lRes := DllExecuteCall(::_SetIcon, xValue, NIL) == 1
   ENDIF
RETURN lRes


///////////////////////////////////////////////////////////////////////////
//  SetTitle() -  Title of taskbar FastReport-window
///////////////////////////////////////////////////////////////////////////

METHOD frReportManager:SetTitle(cTitle)
RETURN DllExecuteCall(::_SetTitle, cTitle) = 1


//////////////////////////////////////////////////////////////////////////////
//  SetVisualActions() - Define action which will execute before and after
//                       such methods as ShowReport, DesignReport etc.
//                       nAction - The following values are available:
//                         FR_ACT_NONE(0) - no action
//                         FR_ACT_HIDE(1) -
//                                SetAppWindow():hide()
//                                   METHOD
//                                SetAppWindow():show()
//                         FR_ACT_DISABLE(2) -
//                                SetAppWindow():disable()
//                                   METHOD
//                                SetAppWindow():enable()
//                         FR_ACT_USER(3)
//                                bBeforeAction
//                                  METHOD
//                                bAfterAction
//                         Default - FR_ACT_NONE
//
//                       lTaskListToFalse - if true:
//                                SetAppWindow():taskList := .f.
//                                   METHOD
//                                SetAppWindow():taskList := .t.
//                         Default - False
//////////////////////////////////////////////////////////////////////////////

METHOD frReportManager:SetVisualActions(nAction, lTaskListToFalse, bBeforeAction, bAfterAction)
PRIVATE tmp_ParamB,tmp_ParamA
   IF nAction = FR_ACT_USER
     tmp_ParamB := bBeforeAction
     tmp_ParamA := bAfterAction
   ENDIF
   lTaskListToFalse := IF(lTaskListToFalse <> NIL, IF(lTaskListToFalse, 1, 0), 0)
RETURN DllExecuteCall(::_SetVisualActions, nAction, lTaskListToFalse) = 1


///////////////////////////////////////////////////////////////////////////
//  LoadLangRes() - Load language resource file
///////////////////////////////////////////////////////////////////////////

METHOD frReportManager:LoadLangRes(cLangFile)
RETURN DllExecuteCall(::_LoadLangRes, cLangFile) = 1


//////////////////////////////////////////////////////////////////////////
//  ShowReport() - Starts a report and displays a result in the preview
//                 window. If the "nNotClear" parameter is equal to
//                 "FR_NOTCLEARLASTREPORT"(1) then a report will be added
//                 to the previously constructed one, otherwise the
//                 previously constructed report is cleared (by default).
//////////////////////////////////////////////////////////////////////////

METHOD frReportManager:ShowReport(nNotClear)
   ::bSaveError := ErrorBlock( {|oError| ::FrNotifyError(oError) })
   nNotClear := IF(nNotClear <> NIL, nNotClear, 0)
   DllExecuteCall(::_ShowReport, nNotClear)
   ErrorBlock( ::bSaveError )
RETURN self


///////////////////////////////////////////////////////////////////////////
//  PrepareReport() - Starts a report without a preview window.
//                    nNotClear - the same as in ShowReport()
///////////////////////////////////////////////////////////////////////////

METHOD frReportManager:PrepareReport(nNotClear)
LOCAL RES
   ::bSaveError := ErrorBlock( {|oError| ::FrNotifyError(oError) })
   nNotClear := IF(nNotClear <> NIL, nNotClear, 0)
   RES := DllExecuteCall(::_PrepareReport, nNotClear) = 1
   ErrorBlock( ::bSaveError )
RETURN RES


///////////////////////////////////////////////////////////////////////////
//  ShowPreparedReport() - Displays the report, which was previously built
//                         via the "PrepareReport" call.
///////////////////////////////////////////////////////////////////////////

METHOD frReportManager:ShowPreparedReport()
   ::bSaveError := ErrorBlock( {|oError| ::FrNotifyError(oError) })
   DllExecuteCall(::_ShowPreparedReport)
   ErrorBlock( ::bSaveError )
RETURN self


////////////////////////////////////////////////////////////////////////
//  DesignReport() - Calls the report designer
////////////////////////////////////////////////////////////////////////

METHOD frReportManager:DesignReport()
   ::bSaveError := ErrorBlock( {|oError| ::FrNotifyError(oError) })
   DllExecuteCall(::_DesignReport)
   ErrorBlock( ::bSaveError )
RETURN self


////////////////////////////////////////////////////////////////////////
//  LoadFromFile() - Loads a report from a file with given name.
//                   Returns .t. if the file is loaded successfully
////////////////////////////////////////////////////////////////////////

METHOD frReportManager:LoadFromFile(cFileName)
RETURN DllExecuteCall(::_LoadFromFile, cFileName) = 1


////////////////////////////////////////////////////////////////////////
//  LoadFromResource() - Loads a report from a resource with given name
//                       or number.  Returns .t. if the file is loaded
//                       successfully
////////////////////////////////////////////////////////////////////////

METHOD frReportManager:LoadFromResource(xValue)
LOCAL lRes
   IF ValType(xValue) = "C"
      lRes := DllExecuteCall(::_LoadFromResource, 0, xValue) == 1
   ELSE
      lRes := DllExecuteCall(::_LoadFromResource, xValue, NIL) == 1
   ENDIF
RETURN lRes


////////////////////////////////////////////////////////////////////////
//  LoadFromBlob() - Loads a report from a memo or blob field.
//                   Returns .t. if the file is loaded successfully
////////////////////////////////////////////////////////////////////////

METHOD frReportManager:LoadFromBlob(nWorkArea, cFieldName)
RETURN DllExecuteCall(::_LoadFromBlob, nWorkArea, cFieldName) = 1


////////////////////////////////////////////////////////////////////////
//  SaveToFile() - Saves a report to a file with given name.
////////////////////////////////////////////////////////////////////////

METHOD frReportManager:SaveToFile(cFileName)
  DllExecuteCall(::_SaveToFile, cFileName)
RETURN self


////////////////////////////////////////////////////////////////////////
//  SaveToBlob() - Saves a report to a memo or blob field.
////////////////////////////////////////////////////////////////////////

METHOD frReportManager:SaveToBlob(nWorkArea, cFieldName)
RETURN DllExecuteCall(::_SaveToBlob, nWorkArea, cFieldName)


////////////////////////////////////////////////////////////////////////
//  Clear() - Clears a report.
////////////////////////////////////////////////////////////////////////

METHOD frReportManager:Clear()
  DllExecuteCall(::_Clear)
RETURN self



////////////////////////////////////////////////////////////////////////
//  LoadStyleSheet() - Loads Style Sheet
////////////////////////////////////////////////////////////////////////

METHOD frReportManager:LoadStyleSheet(cFileName)
   DllExecuteCall(::_LoadStyleSheet, cFileName)
RETURN self


////////////////////////////////////////////////////////////////////////////
//  Print() - Prints a report. See frPrintOptions class.
//            lDialogIsChild - if true then PrintDialog will be the child of
//                               current foreground window
//                    Default -False
////////////////////////////////////////////////////////////////////////////

METHOD frReportManager:Print(lDialogIsChild)
LOCAL RES
  ::bSaveError := ErrorBlock( {|oError| ::FrNotifyError(oError) })
  lDialogIsChild := IF(lDialogIsChild <> nil, IF(lDialogIsChild, 1, 0), 0)
  RES := DllExecuteCall(::_Print, lDialogIsChild) = 1
  ErrorBlock( ::bSaveError )
RETURN RES


////////////////////////////////////////////////////////////////////////
// GetErrors() - Get Errors list. Impotant in silent mode.
////////////////////////////////////////////////////////////////////////

METHOD frReportManager:GetErrors()
PRIVATE tmp_RetVal
  DllExecuteCall(::_GetErrors)
RETURN tmp_RetVal


////////////////////////////////////////////////////////////////////////
// DoExport() - Exports a report using the specified export filter
//              object. Possible values of Param:
//
//                  PDFExport, HTMLExport, RTFExport, CSVExport,
//                  XLSExport, DotMatrixExport, BMPExport, JPEGExport,
//                  TIFFExport, GIFExport, SimpleTextExport, MailExport,
//                  XMLExport, TXTExport
//
////////////////////////////////////////////////////////////////////////

METHOD frReportManager:DoExport(cExportObjectName)
  DllExecuteCall(::_DoExport, cExportObjectName)
RETURN Self


////////////////////////////////////////////////////////////////////////
// GetProperty()/  Universal functions that set or return any property
// SetProperty() - (except object property) of any Fast Report object.
//                   Possible values of sObjectName:
//
//                  Report, Designer,
//                  PDFExport, HTMLExport, RTFExport, CSVExport,
//                  XLSExport, DotMatrixExport, BMPExport, JPEGExport,
//                  TIFFExport, GIFExport, SimpleTextExport, MailExport
//
//                  For properties of objects that is property of this
//                  "main" objects '.'-delimeter must be used. For
//                  example:
//                    "Designer.DefaultFont"
//
//                  For full list of values for sPropName param see Fast
//                  Report documentation:
//                   http://www.fast-report.com/en/documentation/
//
//                  Examples:
//                    SetProperty("Report", "ScriptLanguage", "PascalScript")
//                    SetProperty("PDFExport", "FileName", "My file.pdf")
//                    SetProperty("PDFExport", "ShowDialog", .f.)
//
//                  For Delphi enumerated types and set type use its
//                  string representation, for example:
//                    SetProperty("Designer.DefaultFont", "Style", "[fsBold, fsItalic]")
//
////////////////////////////////////////////////////////////////////////

METHOD frReportManager:GetProperty(sObjectName, sPropName)
PRIVATE tmp_RetVal
   DllExecuteCall(::_GetProperty, sObjectName, sPropName)
RETURN tmp_RetVal

METHOD frReportManager:SetProperty(sObjectName, sPropName, Value)
PRIVATE tmp_Param := Value
RETURN DllExecuteCall(::_SetProperty, sObjectName, sPropName) = 1


////////////////////////////////////////////////////////////////////////
//  SetEventHandler() - Set Event Handler (codeblock) to Fast Report
//                      event. Possible values of params:
//          sObjectName - Report:
//                          sPropName: OnAfterPrint(sObjName),
//                                     OnAfterPrintReport(),
//                                     OnBeforeConnect(sConnectName),
//                                     OnBeforePrint(sObjName),
//                                     OnBeginDoc(),
//                                     OnClickObject(sObjName, nButton),
//                                     OnEndDoc(),
//                                     OnGetValue(sVarName) -> VarValue ,
//                                     OnManualBuild -- !!! not implemented yet!,
//                                     OnMouseOverObject(sObjName),
//                                     OnPreview(),
//                                     OnPrintPage(nCopyNo),
//                                     OnPrintReport(),
//                                     OnProgress(nProgressType, nProgress),
//                                     OnProgressStop(nProgressType, nProgress),
//                                     OnProgressStart(nProgressType, nProgress),
//                                     OnUserFunction(sMethodName, aParams) -> xResult
//
//         sObjectName - Designer:
//                          sPropName: OnInsertObject(),
//                                     OnLoadReport(),
//                                     OnSaveReport(bSaveAs),
//                                     OnShow(),
//                                     OnShowStartupScreen()
//
//         Example:
//            SetEventHandler("Report", "OnProgress", {|x,y|MyShowProgress(x, y)})
//
//         To clear EventHandler pass NIL as bEventHandler param
//
////////////////////////////////////////////////////////////////////////

METHOD frReportManager:SetEventHandler(cObjectName, cPropName, bEventHandler)
PRIVATE tmp_Param := bEventHandler
RETURN DllExecuteCall(::_SetEventHandler, cObjectName, cPropName) = 1


////////////////////////////////////////////////////////////////////////
//  AddFunction() - Adds a user function to the list of the functions
//                  available in the report. OnUserFunction-eventhandler
//                  must be assigned.
//                    cFunction - function declaration in Pascal syntax.
//
////////////////////////////////////////////////////////////////////////

METHOD frReportManager:AddFunction(cFunction, cCategory, cDescription)
   DllExecuteCall(::_AddFunction, cFunction, IF(cCategory <> NIL, cCategory, "") , IF(cDescription <> NIL, cDescription, ""))
RETURN Self


/////////////////////////////////////////////////////////////////////////
//  AddVariable() - Adds a user variable to the list of the variables
//                  available in the report.
//
//    IMPOTANT:  When accessing a report variable its value is calculated
//               if it is of string type. That means the variable which
//               value is "GetXppVar(SomeVar)"  will return a value of
//               SomeVar - variable, but not the "GetXppVar(SomeVar)" string.
//               You should be careful when assigning a string-type values
//               to report variables. Simple string value must be in
//               Pascal string quotes - '
//                Examples for xValue:
//                  "GetXppVar(SomeVar)"  -> Value of SomeVar
//                  "'GetXppVar(SomeVar)'" -> string
//
/////////////////////////////////////////////////////////////////////////

METHOD frReportManager:AddVariable(cCategory, cName, xValue)
PRIVATE tmp_Param := xValue
   DllExecuteCall(::_AddVariable, cCategory, cName)
RETURN Self


/////////////////////////////////////////////////////////////////////////
//  SetVariable() - Modify a user variables value
/////////////////////////////////////////////////////////////////////////

METHOD frReportManager:SetVariable(cName, xValue)
PRIVATE tmp_Param := xValue
   DllExecuteCall(::_SetVariable, cName)
RETURN Self


/////////////////////////////////////////////////////////////////////////
//  GetVariable() - Get a user variables value
/////////////////////////////////////////////////////////////////////////

METHOD frReportManager:GetVariable(cName)
PRIVATE tmp_RetVal
   DllExecuteCall(::_GetVariable, cName)
RETURN tmp_RetVal


/////////////////////////////////////////////////////////////////////////
//  DeleteVariable() - Delete a user variable
/////////////////////////////////////////////////////////////////////////

METHOD frReportManager:DeleteVariable(cName)
   DllExecuteCall(::_DeletVariable, cName)
RETURN Self


/////////////////////////////////////////////////////////////////////////
//  DeletCategory() - delete a category with ALL its variables.
/////////////////////////////////////////////////////////////////////////

METHOD frReportManager:DeleteCategory(cCategory)
   DllExecuteCall(::_DeletCategory, cCategory)
RETURN Self


/////////////////////////////////////////////////////////////////////////
//  SetScriptVar()/ - Get or Set script variable
//  GetScriptVar
//                  Instead of report variables, script variables are
//                  not visible in the report variables list and is not
//                  calculated. You can define them using FastScript
//                  methods
/////////////////////////////////////////////////////////////////////////

METHOD frReportManager:SetScriptVar(sName, xValue)
PRIVATE tmp_Param := xValue
   DllExecuteCall(::_SetScriptVar, sName)
RETURN Self

METHOD frReportManager:GetScriptVar(sName)
PRIVATE tmp_RetVal
   DllExecuteCall(::_GetScriptVar, sName)
RETURN tmp_RetVal


/////////////////////////////////////////////////////////////////////////
//  Calc() - Calculates the any FastScript expression and returns the
//           result.
/////////////////////////////////////////////////////////////////////////

METHOD frReportManager:Calc(sExpression)
PRIVATE tmp_RetVal
   DllExecuteCall(::_Calc, sExpression)
RETURN tmp_RetVal


////////////////////////////////////////////////////////////////////////////
//  SetWorkArea() - Add WorkArea or modify params of WorkArea.
//                  sFrAlias     - any string that will represent WorkArea in FR
//                  nWorkArea    - number of WorkArea
//                  lOem         - data in oem codepage (default - .f.)
//                  aRangeParams - Range Params. Array with 3 elements:
//                    1 element - FR_RB_FIRST(0) or FR_RB_CURRENT(1)
//                    2 element - FR_RE_LAST(0) or FR_RE_CURRENT(1) or FR_RE_COUNT(2)
//                    3 element - A number of records in the WorkArea,
//                                if the second element = FR_RE_COUNT.
//                      Default - {FR_RB_FIRST, FR_RE_LAST, 0}
////////////////////////////////////////////////////////////////////////////

METHOD frReportManager:SetWorkArea(cFrAlias, nWorkArea, lOem, aRangeParams)
PRIVATE tmp_Params := aRangeParams
   lOem := IF(lOem <> NIL, IF(lOem, 1, 0), 0)
   aRangeParams := IF(aRangeParams <> NIL, 1, 0)
RETURN DllExecuteCall(::_SetWorkArea, cFrAlias, nWorkArea, lOem, aRangeParams) = 1


////////////////////////////////////////////////////////////////////////
//  SetMasterDetail() - Creating master/detail relationships
//                      between two WorkAreas (Delphi realization based on
//                      "DbScope" - XBase++ functions).
//
//                      Example - SetMasterDetail("Customers", "Orders", {||Customers->CustNo})
////////////////////////////////////////////////////////////////////////

METHOD frReportManager:SetMasterDetail(cMasterAlias, cDetailAlias, bScopeValue)
PRIVATE tmp_Param := bScopeValue
RETURN DllExecuteCall(::_SetMasterDetail, cMasterAlias, cDetailAlias) = 1


////////////////////////////////////////////////////////////////////////////
//  SetResyncPair() - When DbRelation-relationships is set in XBase++
//                    code, you need notify FastReport about it.
//
//                    It means that after  changing of parent workarea cursor
//                    position, child dataset resynchronize its cursor position
//                    with XBase++ data.
////////////////////////////////////////////////////////////////////////////

METHOD frReportManager:SetResyncPair(cParentAlias, cChildlAlias)
RETURN DllExecuteCall(::_SetResyncPair, cParentAlias, cChildlAlias) = 1


////////////////////////////////////////////////////////////////////////
//  SetUserDataSet() - Add or modify UserDataSet. UserDataSet allows
//                     constructing reports, which are not connected
//                     to the data from DB, but do receive data from
//                     other sources (for example, array, file, etc.).
////////////////////////////////////////////////////////////////////////

METHOD frReportManager:SetUserDataSet(sFrAlias, sFields, bGoTop, bSkipPlus1, bSkipMinus1, ;
                                                bCheckEOF, bGetValue)
PRIVATE tmp_Params := {bGoTop, bSkipPlus1, bSkipMinus1, bCheckEOF, bGetValue}
RETURN DllExecuteCall(::_SetUserDataSet, sFrAlias, sFields) = 1


////////////////////////////////////////////////////////////////////////
//  Resync() - method for resynchronize the dataset with underlying
//             physical data when making XBase++ calls that may change
//             the workarea cursor position.
////////////////////////////////////////////////////////////////////////

METHOD frReportManager:Resync(cFrAlias)
RETURN DllExecuteCall(::_Resync, cFrAlias) = 1

///////////////////////////////////////////////////////////////////////////////////////
//  SetFieldAliases() - Set symbolic names of data set fields and
//                      show/hide some fields. For example:
//         SetFieldAliases("Customers", "CUSTNO=Cust No;Company;ADDR1=Address;Phone")
//
//         Only 4 fields will be visible, CUSTNO and ADDR1 will be visible as 'Cust No'
//         and 'Address'
///////////////////////////////////////////////////////////////////////////////////////

METHOD frReportManager:SetFieldAliases(cFrAlias, cFieldAliases)
RETURN DllExecuteCall(::_SetFieldAliases, cFrAlias, cFieldAliases) = 1


////////////////////////////////////////////////////////////////////////
//  RemoveDataSet() - Remove WorkArea or UserDataSet from Fast Report
//                    data list.
////////////////////////////////////////////////////////////////////////

METHOD frReportManager:RemoveDataSet(cFrAlias)
RETURN DllExecuteCall(::_RemoveDataSet, cFrAlias) = 1


////////////////////////////////////////////////////////////////////////
//  ClearDataSets() - Remove All WorkAreas and UserDataSets from Fast
//                    Report data list.
////////////////////////////////////////////////////////////////////////

METHOD frReportManager:ClearDataSets()
   DllExecuteCall(::_ClearDataSets)
RETURN self


////////////////////////////////////////////////////////////////////////
//  ClearMasterDetail() - Remove  master/detail relationships
//                        between two WorkAreas
////////////////////////////////////////////////////////////////////////

METHOD frReportManager:ClearMasterDetail(cDetailAlias)
   DllExecuteCall(::_ClearMasterDetail, cDetailAlias)
RETURN self


////////////////////////////////////////////////////////////////////////
//  ClearResyncPair() -   Remove  "resync" relationships
//                        between two WorkAreas
////////////////////////////////////////////////////////////////////////

METHOD frReportManager:ClearResyncPair(cParentAlias, cChildlAlias)
RETURN DllExecuteCall(::_ClearResyncPair, cParentAlias, cChildlAlias) = 1


////////////////////////////////////////////////////////////////////////
//  SetADOConnectStr() - Set ConnectionString for ADO-DataBase object
////////////////////////////////////////////////////////////////////////

METHOD frReportManager:SetADOConnectStr(sFrAlias, sStr)
RETURN DllExecuteCall(::_SetADOConnectStr, sFrAlias, sStr) = 1


/////////////////////////////////////////////////////////////////////////////////
//  SetADOConnectPartStr() - Set only one part of ConnectionString
//                           for ADO-DataBase object. For examle:
//     SetADOConnectPartStr("ADODatabase1", "Data Source", SomeFile)
/////////////////////////////////////////////////////////////////////////////////

METHOD frReportManager:SetADOConnectPartStr(sFrAlias, sKey, sValue)
RETURN DllExecuteCall(::_SetADOConnectPartStr, sFrAlias, sKey, sValue) = 1



METHOD frReportManager:StartManualBuild(bManualBlock, nOrientation, nPaperSize, nUnits)
PRIVATE tmp_Param := bManualBlock
   nOrientation := IF(nOrientation <> NIL, nOrientation, 0)
   nPaperSize := IF(nPaperSize <> NIL, nPaperSize, -1)
   nUnits := IF(nUnits <> NIL, nUnits, FR_PIXELS)
   DllExecuteCall(::_StartManualBuild, nOrientation, nPaperSize, nUnits)
RETURN


METHOD frReportManager:MemoAt(cStr, nLeft, nTop, nWidth, nHeight)
PRIVATE tmp_Param := {nLeft, nTop, nWidth, nHeight}, tmp_Result := ""
   DllExecuteCall(::_MemoAt, cStr)
RETURN tmp_Result


METHOD frReportManager:SetDefaultFontProperty(cPropName, xValue)
PRIVATE tmp_Param := xValue
//LOCAL tmp_Param := xValue
   DllExecuteCall(::_SetDefaultFontProperty, cPropName)
RETURN


METHOD frReportManager:NewPage()
   DllExecuteCall(::_NewPage)
RETURN


METHOD frReportManager:SetManualObjProperty(cObjName, cPropName, xValue)
PRIVATE tmp_Param := xValue
   DllExecuteCall(::_SetManualObjProperty, cObjName, cPropName)
RETURN


METHOD frReportManager:LineAt(nLeft, nTop, nWidth, nHeight)
PRIVATE tmp_Param := {nLeft, nTop, nWidth, nHeight}, tmp_Result := ""
   DllExecuteCall(::_LineAt)
RETURN tmp_Result


METHOD frReportManager:PictureAt(cFileName, nLeft, nTop, nWidth, nHeight)
PRIVATE tmp_Param := {nLeft, nTop, nWidth, nHeight}, tmp_Result := ""
   DllExecuteCall(::_PictureAt, cFileName)
RETURN tmp_Result


METHOD frReportManager:SendMail(cServer, nPort, cUserField, cPasswordField,;
       cFromField, cToField, cSubjectField, cCompanyField,;
       cTextField, cFileNames)
PRIVATE tmp_Result := ""

   DllExecuteCall(::_SendMail, cServer, nPort, cUserField, cPasswordField,;
       cFromField, cToField, cSubjectField, cCompanyField, cTextField, cFileNames)
RETURN tmp_Result



//////////////////////////////////////////////////////////////////////
//
//  DELPHI.PRG
//
//  Copyright:
//       Spirin Sergey, Paritet Soft, (c) 1992-2007. All rights reserved.
//
//  Contents:
//       Set of technical function for realization
//       TAlaskaDataSet component in Delphi and run-time routine
//
//
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// fnDBStruct - return DbStruct() in one delimited string
//////////////////////////////////////////////////////////////////////

FUNCTION fnDBStruct()
LOCAL Result := '', Arr, x, y
  Arr := DbStruct()
  for x = 1 to Len(Arr)
    for y = 1 to Len(Arr[x])
      DO CASE
        CASE (y = 1)
          Result := Result + Arr[x,y]
        CASE (y = 2)
          Result := Result + ',' + Arr[x,y]
        CASE (y = 3).or.(y = 4)
          Result := Result + ',' + Alltrim(Str(Arr[x,y], 10, 0))
      ENDCASE
    next
    Result := Result + ';'
  next
RETURN Result

//////////////////////////////////////////////////////////////////////
// CheckDBELoaded - Check DBE Loaded :)
//////////////////////////////////////////////////////////////////////

FUNCTION CheckDBELoaded(DBEName)
LOCAL aDBE := DbeList(), x, Res
  Res := .f.
  for x = 1 to Len(aDBE)
    if aDBE[x,1] == DBEName
      Res := .t.
      exit
    endif
  next
RETURN Res

//////////////////////////////////////////////////////////////////////
// DoNothing - empty procedure, it is used for correct
//             work of Xbase ++ garbage collector
//////////////////////////////////////////////////////////////////////

Procedure DoNothing
Return

